
.686
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

  
include \masm32\include\windows.inc
include     \masm32\macros\timers.asm      
include     \masm32\macros\macros.asm    
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\include\msvcrt.inc
include \masm32\include\shlwapi.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\msvcrt.lib
includelib \masm32\lib\shlwapi.lib
InStringL proto :DWORD, :DWORD

InStringx PROTO :DWORD,:DWORD,:DWORD

.data
Mainstr db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wings",0

Substrx  db "wings",0
cl1 dd 0
cl2 dd 0
cl3 dd 0

.data?
NTstrstr dd ?

.code
start:

REPEAT 8

LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke crt_strstr,addr Mainstr,addr Substrx
counter_end
add cl1, eax
print str$(eax)," timing msvcrt strstr",13,10

LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke InStringx,1,addr Mainstr,addr Substrx
counter_end
add cl2, eax
print str$(eax)," timing InStringx",13,10

LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke InStringL,addr Mainstr,addr Substrx
counter_end
add cl3, eax
print str$(eax)," timing InStringL",13,10

ENDM

shr cl1, 3
shr cl2, 3
shr cl3, 3

print "----------------------",13,10
print str$(cl1)," average msvcrt strstr",13,10
print str$(cl2)," average InStringx",13,10
print str$(cl3)," average InStringL",13,10
print "----------------------",13,10




inkey

invoke ExitProcess,0

; 
 
OPTION PROLOGUE:NONE                    ; turn it off
OPTION EPILOGUE:NONE                    ;
Align 16                                ; Align 16 before the proc
InStringL proc lpSource:DWORD, lpPattern:DWORD
         db    3Eh                     ; ds: prefix
         mov   eax, [esp+8]            ; ecx->lpPattern
         sub   esp, 2*4                ; room to save registers and lenght of substring
         db    3Eh                     ;
         mov   edx, [esp+2*4]          ; edx-> return address
         db    3Eh                     ;
         mov   ecx, [eax]              ; get dword from substring
         db    3Eh                     ;
         mov   [esp+2*4], ebx          ; save register ebx
         movzx ebx, cl                 ; ebx->the 1st byte of substring
         db    3Eh                     ;
         mov   [esp+4*4], edx          ; save return address
         imul  ebx, 1010101h           ; ebx=77 77 77 77h  ; 77h -> ASCII code of "w"
         db    3Eh                     ;   (if the 1st byte of substring is "w")
         mov   [esp], esi              ;          
         lea   esi, [eax-1]            ; esi-> lpPattern-1
         mov   [esp+1*4], edi          ; save register edi
         mov   edx, 80808080h          ;
         mov   edi, [esp+3*4]          ; edi-> lpSource
         mov   [esp+3*4], ebp          ; save register ebp
         mov   ebp, 0FEFEFEFFh         ; ebp=0FEFEFEFFh
LoopS1:                                 ; my strlen with substring
         add   eax, 4                  ; ecx->lpPattern
         add   ecx, ebp                ; ebp=0FEFEFEFFh
         test  edx, ecx                ;
         mov   ecx, [eax]              ; get dword from substring
         je    LoopS1                  ; 2 clocks per 4 bytes
         cmp   byte ptr [eax-4], 0     ;
         je    S1_minus4               ;
         cmp   byte ptr [eax-4+1], 0   ;
         je    S1_minus3               ;
         cmp   byte ptr [eax-4+2], 0   ;
         je    S1_minus2               ;
         cmp   byte ptr [eax-4+3], 0   ;
         jne   LoopS1                  ; if not zeroes loop again
         sub   eax, 2                  ;
S1:                                     ;
         mov   ebp, [edi]              ;
         sub   eax, esi                ; end my strlen with substring
         mov   ecx, -4                 ;
         push  eax                     ; save len of substring in variable
BytesScan:                              ;
         db    3Eh                     ; ds: prefix
         lea   edx, [ebp-1010101h]     ; searching the 1st byte of substring or/and zero
         xor   ebp, ebx                ; ebx=77 77 77 77h  ; 77h -> ASCII code of "w"
         db    3Eh                     ;   (if the 1st byte of substring is "w")
         add   edi, 4                  ;              
         sub   ebp, 1010101h           ;
         or    edx, ebp                ; testing the 1st byte of substring and 0
         db    3Eh                     ;   simultaneously in the larger string
         mov   ebp, [edi]              ;  
         and   edx, 80808080h          ;
         je    BytesScan               ; 4 clocks per 4 bytes
SrchNextByte:                           ;
         cmp   [edi+ecx], bl           ; bl = 77h -> ASCII code of "w
         je    StartCmp                ;   (if the 1st byte of substring is "w")
         cmp   byte ptr [edi+ecx], 0   ; is it the end of the larger string?
         je    ExitP                   ; exit
ToNext:                                 ;
         inc   ecx                     ; ecx-> -4 to 0
         jne   SrchNextByte            ;
         mov   ebp, [edi]              ; restoring ebp for ByteScan
         sub   ecx, 4                  ; ecx = -4
         jc    BytesScan               ; loop again
align 16                                ;
S1_minus4:                              ;
         db    3Eh                     ; ds: prefix
         sub   eax, 5                  ;
         jno   S1                      ;
S1_minus3:                              ;
         sub   eax, 4                  ;
         jno   S1                      ;
S1_minus2:                              ;
         sub   eax, 3                  ;
         jno   S1                      ;
StartCmp:                               ; comparing next bytes from substring
         mov   edx,  [esp]             ; edx-> len of substring
         lea   ebp, [edi+ecx]          ; ebp=edi+ecx -> as a base register
         movzx eax, byte ptr [esi+edx] ; comparing rest bytes
         dec   edx                     ;
         je    ExitP                   ; exit
CmpNext:                                ;
         cmp   [ebp+edx], al           ; ebp->lp to current 1st byte in the larger string
         jne   ToNext                  ;
         movzx eax, byte ptr [esi+edx] ; get next byte
         dec   edx                     ;
         jne   CmpNext                 ; 2 clocks per byte
ExitP:                                  ;
         mov   esi, [esp+1*4]          ; restoring register esi
         cmp   edx, 1                  ; if edx= 0 mask = 0FFFFFFFFh else mask=0
         sbb   eax, eax                ; eax->mask 0 or 0FFFFFFFFh
         mov   edi, [esp+2*4]          ; restoring register edi
         and   eax, ebp                ; eax->lp 1st occurrence in large string or zero
         mov   ebx, [esp+3*4]          ; restoring register ebx
         mov   ebp, [esp+4*4]          ; restoring register ebp
         add   esp, 5*4                ; restoring register esp
         ret                           ; faster return then ret  2*4
InStringL endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

align 16

InStringx proc startpos:DWORD,lpSource:DWORD,lpPattern:DWORD

    LOCAL sLen:DWORD
    LOCAL pLen:DWORD

    push ebx
    push esi
    push edi

    invoke StrLen,lpSource
    mov sLen, eax           ; source length
    invoke StrLen,lpPattern
    mov pLen, eax           ; pattern length

    cmp startpos, 1
    jge @F
    mov eax, -2
    jmp isOut               ; exit if startpos not 1 or greater
  @@:

    sub startpos, 1         ; correct from 1 to 0 based index

    cmp  eax, sLen
    jl @F
    mov eax, -1
    jmp isOut               ; exit if pattern longer than source
  @@:

    sub sLen, eax           ; don't read past string end
    add sLen, 1

    mov ecx, sLen
    cmp ecx, startpos
    jg @F
    mov eax, -2
    jmp isOut               ; exit if startpos is past end
  @@:

  ; ----------------
  ; setup loop code
  ; ----------------
    mov esi, lpSource
    mov edi, lpPattern
    movzx eax, BYTE PTR [edi]

    add esi, ecx            ; add source length
    neg ecx                 ; invert sign
    add ecx, startpos       ; add starting offset

    jmp Scan_Loop

    align 16

  ; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  Pre_Scan:
    pop eax
    add ecx, 1              ; start on next byte

  Scan_Loop:
  REPEAT 15
    cmp al, [esi+ecx]       ; scan for 1st byte of pattern
    je Pre_Match            ; test if it matches
    add ecx, 1
    jns No_Match
  ENDM

    cmp al, [esi+ecx]       ; scan for 1st byte of pattern
    je Pre_Match            ; test if it matches
    add ecx, 1
    js Scan_Loop            ; exit on sign inversion

    jmp No_Match

  align 16
  Pre_Match:
    push eax
    lea ebx, [esi+ecx]      ; put current scan address in EBX
    mov edx, pLen           ; put pattern length into EDX

  Test_Match:
  REPEAT 7
    movzx eax, BYTE PTR [ebx+edx-1]     ; load last byte of pattern length in main string
    cmp al, [edi+edx-1]     ; compare it with last byte in pattern
    jne Pre_Scan            ; jump back on mismatch
    sub edx, 1
    jz Match                ; 0 = match, fall through on match
  ENDM

    movzx eax, BYTE PTR [ebx+edx-1]     ; load last byte of pattern length in main string
    cmp al, [edi+edx-1]     ; compare it with last byte in pattern
    jne Pre_Scan            ; jump back on mismatch
    sub edx, 1
    jnz Test_Match          ; 0 = match, fall through on match

  ; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  Match:
    pop eax
    add ecx, sLen
    mov eax, ecx
    add eax, 1
    jmp isOut
    
  No_Match:
    pop eax
    xor eax, eax

  isOut:

    pop edi
    pop esi
    pop ebx

    ret

InStringx endp

; 

end start


